local _, addon = ...

-- functions
local print, select, tostring, type = print, select, tostring, type
local format = string.format
local GetRealmName = GetRealmName
local UnitClass = UnitClass
local UnitFactionGroup = UnitFactionGroup
local UnitName = UnitName
-- constants
-- frames
-- libs

function addon:Print(...)
    local obj
    for i = 1, #... do
        obj = select(i, ...)
        if obj and type(obj) == "table" then
            print(format("|cff%sBK:|r", "6699CC"))
            DevTools_Dump(obj)
        elseif obj then
            print(format("|cff%sBK:|r %s", "6699CC", type(obj) == "string" and format(obj, ...) or tostring(obj)))
        end
    end
end

function addon:Debug(...)
    if not ... or not self.options or self.options.debug ~= true then return end

    return self:Print(...)
end

function addon:Initialise(db)
    self:Debug("Initialising.")

    local playerPool = "player"

    self.db = db

    self.db.pools = self.db.pools or {}
    self.db.pools[playerPool] = self.db.pools[playerPool] or {}

    local key = self:GetCharacterKey()
    self.db.pools[playerPool][key] = self.db.pools[playerPool][key] or self:GetPlayerInfo()

    self.player = self.db.pools[playerPool][key]

    self:Fire(self.EVENT_INITIALISED)
end

function addon:GetPlayerInfo()
    local unit = "player"

    return {
        realm = GetRealmName(),
        faction = UnitFactionGroup(unit),
        name = select(1, UnitName(unit)),
        class = select(2, UnitClass(unit)),
    }
end

addon:RegisterCallback(addon.EVENT_INITIALISED, function()
    addon:Debug("Ready.")
end)
