local _, addon = ...

-- functions
local setmetatable = setmetatable
-- constants
-- frames
-- libs

local proxy
local metatable = {
    __index = function(self, key)
        local value = proxy[key]
        return value
    end,
    __newindex = function(self, key, value)
        local old = proxy[key]
        proxy[key] = value
        addon:Fire(addon.EVENT_OPTION_CHANGED, key, value, old)
    end,
}

addon:RegisterCallback(addon.EVENT_INITIALISED, function()
    addon.db.options = addon.db.options or {}

    proxy = addon.db.options
    addon.options = setmetatable({}, metatable)

    addon.options.useShorthand = addon.options.useShorthand or false
end)

function addon:ToggleAbbreviatedDungeonNames()
    self.options.useShorthand = not self.options.useShorthand
end
